var br_saved_timeout;
var br_savin_ajax = false;
(function ($){
    $(document).ready( function () {
        var last_search = '';
        var delay_search = false;
        var ajax_request = false;
        $('.products_of_day_submit_form').submit( function(event) {
            event.preventDefault();
            if( !br_savin_ajax ) {
                br_savin_ajax = true;
                var form_data = $(this).serialize();
                form_data = 'action=br_products_of_day_settings_save&'+form_data;
                var url = ajaxurl;
                clearTimeout(br_saved_timeout);
                destroy_br_saved();
                $('body').append('<span class="br_saved br_saving"><i class="fa fa-refresh fa-spin"></i></span>');
                $.post(url, form_data, function (data) {
                    if($('.br_saved').length > 0) {
                        $('.br_saved').removeClass('br_saving').find('.fa').removeClass('fa-spin').removeClass('fa-refresh').addClass('fa-check');
                    } else {
                        $('body').append('<span class="br_saved"><i class="fa fa-check"></i></span>');
                    }
                    br_saved_timeout = setTimeout( function(){destroy_br_saved();}, 5000 );
                    br_savin_ajax = false;
                }, 'json').fail(function() {
                    if($('.br_saved').length > 0) {
                        $('.br_saved').removeClass('br_saving').addClass('br_not_saved').find('.fa').removeClass('fa-spin').removeClass('fa-refresh').addClass('fa-times');
                    } else {
                        $('body').append('<span class="br_saved br_not_saved"><i class="fa fa-times"></i></span>');
                    }
                    br_saved_timeout = setTimeout( function(){destroy_br_saved();}, 5000 );
                    $('.br_save_error').html(data.responseText);
                    br_savin_ajax = false;
                });
            }
        });
        function destroy_br_saved() {
            $('.br_saved').addClass('br_saved_remove');
            var $get = $('.br_saved');
            setTimeout( function(){$get.remove();}, 200 );
        }
        $('.br_settings .nav-tab').click(function(event) {
            event.preventDefault();
            $('.nav-tab-active').removeClass('nav-tab-active');
            $('.nav-block-active').removeClass('nav-block-active');
            $(this).addClass('nav-tab-active');
            $('.'+$(this).data('block')+'-block').addClass('nav-block-active');
        });
        $(window).on('keydown', function(event) {
            if (event.ctrlKey || event.metaKey) {
                switch (String.fromCharCode(event.which).toLowerCase()) {
                case 's':
                    event.preventDefault();
                    $('.products_of_day_submit_form').submit();
                    break;
                }
            }
        });
        $(document).on('click', '.br_products_search', function() {
            $(this).find('.br_search_input').focus();
        });
        $(document).on('click', '.br_products_search .button', function(event) {
            event.stopPropagation();
            $(this).remove();
        });
        $(document).on('click', '.br_search_box', function(event) {
            event.stopPropagation();
            var $current = $(this).find('.br_search_result');
            if( $current.length == 0 ) {
                $('.br_search_result').remove();
                last_search = '';
            } 
        });
        $(document).on('keyup focus', '.br_search_input', function(event) {
            if( delay_search ) {
                clearTimeout(delay_search);
            }
            var $search_block = $(this);
            var $search_box = $search_block.parents('.br_search_box');
            delay_search = setTimeout( function () {
                if( $search_block.val().length >= 3 && $search_block.val() != last_search ) {
                    $search_box.find('.br_search_result').remove();
                    last_search = $search_block.val();
                    var exists = [];
                    $search_box.find('.br_products_suggest input').each(function( i, o ) {
                        exists.push($(o).val());
                    });
                    var data = {
                        action: $search_block.data('action'),
                        term: $search_block.val(),
                        security: br_product_search.security
                    };
                    stop_search();
                    $search_box.find('.br_products_suggest_search').append($('<span class="br_loads"><i class="fa fa-spinner fa-spin"></i></span>'));
                    ajax_request = $.get(ajaxurl, data, function (data) {
                            var count = 0;
                            var html = '<ul class="br_search_result">';
                            $.each(data, function(index, value) {
                                if( $.inArray(index, exists) == -1 ) {
                                    html += '<li data-id="'+index+'">'+value+'</li>';
                                    count++;
                                }
                            });
                            html += '</ul>';
                            if( count > 0 ) {
                                $search_box.append($(html));
                            }
                            $('.br_products_suggest_search .br_loads').remove();
                        }, 'json');
                } else {
                    stop_search();
                }
            }, 500 );
        });
        $(document).on('click', '.br_search_result li', function(event) {
            var $search_box = $(this).parents('.br_search_box');
            var html = '<li class="br_products_suggest button"><input data-name="'+$search_box.data('name')+'" name="'+$search_box.data('name')+'" type="hidden" value="'+$(this).data('id')+'"><i class="fa fa-times"></i>'+$(this).text()+'</li>';
            $search_box.find('.br_products_search li').last().before($(html));
            $search_box.find('.br_search_result').remove();
            last_search = '';
            $search_box.find('.br_search_input').val('');
        });
        $(document).on('click', function(event) {
            $('.br_search_result').remove();
            last_search = '';
            stop_search();
        });
        function stop_search() {
            if ( ajax_request !== false ) {
                ajax_request.abort();
            }
            $('.br_products_suggest_search .br_loads').remove();
        }
        $(document).on('change', '.br_prod_of_day_type', function() {
            $('.br_pod_type_block').hide();
            $('.br_pod_type_block_'+$(this).val()).show();
        });
        $(document).on('change', '.br_pod_use_spec_styles', function() {
            if( $(this).prop('checked') ) {
                $('.berocket_pod_styles_'+$(this).data('id')).show();
            } else {
                $('.berocket_pod_styles_'+$(this).data('id')).hide();
            }
        });
    });
})(jQuery);